unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  a:array[1..30,1..20]of string;
  i,j,n,k,m,s1,s2,r: integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure step (b:TStringGrid; i,j:integer);
BEGIN
  b.Cells[i,j]:=a[i+1,j+1];
  if b.Cells[i,j]=' ' then
     begin
       if (i>0) then
          begin
            if (b.Cells[i-1,j]='?')   then
               step(b,i-1,j);
            if (j>0)    then
               if (b.Cells[i-1,j-1]='?') then
                  step(b,i-1,j-1);
            if (j<s2-1) then
               if (b.Cells[i-1,j+1]='?') then
                  step(b,i-1,j+1)
          end;
       if (i<s1-1) then
          begin
            if (b.Cells[i+1,j]='?')then
               step(b,i+1,j);
            if (j>0)    then
               if (b.Cells[i+1,j-1]='?') then
                  step(b,i+1,j-1);
            if (j<s2-1) then
               if (b.Cells[i+1,j+1]='?') then
                  step(b,i+1,j+1)
          end;
       if (j>0) then
          if (b.Cells[i,j-1]='?')then
             step(b,i,j-1);
       if (j<s2-1)   then
          if (b.Cells[i,j+1]='?')   then
             step(b,i,j+1);
     end
END;


procedure vvod (b: TStringGrid;  i,j:integer);
BEGIN

  if a[i+1,j+1]='+' then
     begin
       showmessage ('На жаль, Ви програли...');
       for i:=0 to s1-1 do for j:=0 to s2-1 do
       b.Cells[i,j]:=a[i+1,j+1]
     end
  else step(b,i,j)
END;


procedure TForm1.Button1Click(Sender: TObject);
begin
  s1:=StrToInt(Edit1.text);      //кількість стовпчиків
  if (s1<4) or (s1>30) then showmessage('Стовпчиків має бути від 4 до 30');
  s2:=StrToInt(Edit2.text);      		//кількість рядків
  if (s2<4) or (s2>20) then showmessage('Рядків має бути від 4 до 20');
  if (s1>=4) and (s1<=30) and (s2>=4) and (s2<=30) then
    begin
      k:=s1*s2;                           //кількість клітинок на полі
      Edit4.text:=IntToStr(k);
      Edit4.visible:=true;
      Label4.visible:=true;
      m:=k div 10;                   //кількість мін
      Edit3.text:=IntToStr(m);
      Edit3.visible:=true;

      r:=0;                              //кількість розкритих клітинок
      Edit5.text:=IntToStr(r);
      Edit5.visible:=true;
      Label5.visible:=true;
      Label6.visible:=true;
      StringGrid1.ColCount:=s1;
      StringGrid1.RowCount:=s2;
      StringGrid1.Height:=s2*22;
      StringGrid1.Width:=s1*22;
      StringGrid1.visible:=true;

      for i:=1 to s1 do for j:=1 to s2 do a[i,j]:='';   //онулення поля
      for i:=0 to s1-1 do for j:=0 to s2-1 do StringGrid1.Cells[i,j]:='?'; //онулення таблиці

      randomize;           	           // розміщення мін
      n:=1;
      while n<=m do
      begin
          i:=random(s1);
          j:=random(s2);
           if a[i+1,j+1]<>'+' then begin
              a[i+1,j+1]:='+';
              inc(n);                end;
      end;

        for i:=1 to s1 do for j:=1 to s2 do      //розміщення чисел
        if a[i,j]<>'+' then
           begin
                n:=0;
                if (i<>1) and (j<>1) and (a[i-1,j-1]='+')  then inc(n);
                if (i<>1) and (a[i-1,j]='+') then inc(n);;
                if (i<>1) and (j<>s2) and (a[i-1,j+1]='+') then inc(n);;
                if (j<>1) and (a[i,j-1]='+')  then inc(n);
                if (j<>s2) and (a[i,j+1]='+') then inc(n);
                if (i<>s1) and (j<>1) and (a[i+1,j-1]='+') then inc(n);
                if (i<>s1) and (a[i+1,j]='+') then inc(n);
                if (i<>s1) and (j<>s2) and (a[i+1,j+1]='+') then inc(n);
                if n<>0 then a[i,j]:=IntToStr(n) else a[i,j]:=' ';
           end;
  end;

end;

procedure TForm1.StringGrid1Click(Sender: TObject);
begin
  n:=StringGrid1.Col;
  k:=StringGrid1.Row;
  vvod(StringGrid1, n,k);
    r:=0;
  for i:=1 to s1 do for j:=1 to s2 do if StringGrid1.Cells[i-1,j-1]<>'?' then r:=r+1;
  Edit5.text:=IntToStr(r);
  if r=strToInt(Edit4.Text)-strToInt(Edit3.Text) then showmessage ('Вітаю, Ви виграли!!!');
end;

end.

